#include <jtest/Unit.hpp>

namespace jtest {
    Unit::Unit(const std::string& name) : event_base(), UnitLogger(name) { //, //ulog(name, jlog::GlobalLogFile) {
        //ulog.IncludeLocation(false);
        this->name = name;
    }

    std::string Unit::Name() { return name; }

    void Unit::Invoke()
    {



        int tests_total = TestCount();
        int tests_ran = 0;
        int tests_passed = 0;
        int tests_failed = 0;

        // TODO: output "Running Test Unit <name> with <N> tests.
        Log(std::format("Running test unit with {} tests...", tests_total));

        for (EventPtr &connection_ptr: this->listeners) {
            //ulog(std::format("Running Test <{}> [{}/{}]", connection_ptr->callback.Name(), tcnt, this->listeners.size()));

            bool this_test_passed = false;

            //LogTestResult(connection_ptr->callback, true);
            //LogTestResult(connection_ptr->callback, false);

            try {
                connection_ptr->Invoke();
                tests_passed++;
                this_test_passed = true;
            } catch(...) {
                tests_failed++;
                this_test_passed = false;
            }

            tests_ran++;

            // TODO: Suffix with [N/M] test index.
            LogTestResult(connection_ptr->callback, this_test_passed, tests_ran, tests_total);

            //tests_ran++;
        }

        LogUnitResult(tests_total, tests_ran, tests_passed, tests_failed);
    }
}